 /*
 * DC motor speed control with PIC12F1822
 * Speed controlled from potentiometer connected
   on RA0.
 * Timer1 interrupts every 100ms for analogue reading.
 * Written by: BENCHEROUDA Okba
 * E-mail: electronnote@gmail.com
 * Website: http://elecnote.blogspot.com/
 * Internal oscillator used at 8MHz
*/

 unsigned int i;
 void Interrupt(){
  if (TMR1IF_bit){
    TMR1IF_bit = 0;
    TMR1H         = 0x3C;
    TMR1L         = 0xB0;
    if(i != ADC_Read(0)){
     i = ADC_Read(0);
     PWM1_Set_Duty((i >> 2)) ;
    }
  }
 }
 void main() {
  OSCCON = 0x70; // Internal oscillator 8MHz
  ANSELA = 1;    // Configure AN0 pin as analogue
  // Initialize Timer1 to Interrupt every 100ms
  T1CON         = 0x21;
  TMR1IF_bit    =    0;
  TMR1H         = 0x3C;
  TMR1L         = 0xB0;
  TMR1IE_bit    =    1;
  INTCON        = 0xC0;
  // End Timer1 initialization
  PORTA = 0;     // Initial value of port A bits
  TRISA = 1;
  PWM1_Init(1000);
  PWM1_Start();
  while(1);  // Endless loop
  }